package sun.java2d.d3d;

import sun.java2d.SurfaceData;
import sun.java2d.loops.CompositeType;
import java.awt.image.LookupOp;
import java.awt.image.RescaleOp;
import java.awt.image.ConvolveOp;
import java.awt.image.BufferedImageOp;
import java.awt.image.BufferedImage;
import sun.java2d.SunGraphics2D;
import sun.java2d.pipe.BufferedBufImgOps;

class D3DBufImgOps extends BufferedBufImgOps
{
    D3DBufImgOps() {
    }
    
    static boolean renderImageWithOp(SunGraphics2D sunGraphics2D, BufferedImage bufferedImage, BufferedImageOp bufferedImageOp, int n, int n2) {
        if ((bufferedImageOp instanceof ConvolveOp)) {
            if (!BufferedBufImgOps.isConvolveOpValid((ConvolveOp)bufferedImageOp)) {
                return false;
            }
        }
        else if ((bufferedImageOp instanceof RescaleOp)) {
            if (!BufferedBufImgOps.isRescaleOpValid((RescaleOp)bufferedImageOp, bufferedImage)) {
                return false;
            }
        }
        else if ((bufferedImageOp instanceof LookupOp)) {
            if (!BufferedBufImgOps.isLookupOpValid((LookupOp)bufferedImageOp, bufferedImage)) {
                return false;
            }
        }
        else {
            return false;
        }
        SurfaceData surfaceData = sunGraphics2D.surfaceData;
        if (!(surfaceData instanceof D3DSurfaceData) || sunGraphics2D.interpolationType == 3 || sunGraphics2D.compositeState > 1) {
            return false;
        }
        SurfaceData surfaceData2 = surfaceData.getSourceSurfaceData(bufferedImage, 0, CompositeType.SrcOver, null);
        if (!(surfaceData2 instanceof D3DSurfaceData)) {
            surfaceData2 = surfaceData.getSourceSurfaceData(bufferedImage, 0, CompositeType.SrcOver, null);
            if (!(surfaceData2 instanceof D3DSurfaceData)) {
                return false;
            }
        }
        D3DSurfaceData d3DSurfaceData = (D3DSurfaceData)surfaceData2;
        D3DGraphicsDevice d3DGraphicsDevice = (D3DGraphicsDevice)d3DSurfaceData.getDeviceConfiguration().getDevice();
        if (d3DSurfaceData.getType() != 3 || !d3DGraphicsDevice.isCapPresent(65536)) {
            return false;
        }
        int width = bufferedImage.getWidth();
        int height = bufferedImage.getHeight();
        D3DBlitLoops.IsoBlit(surfaceData2, surfaceData, bufferedImage, bufferedImageOp, sunGraphics2D.composite, sunGraphics2D.getCompClip(), sunGraphics2D.transform, sunGraphics2D.interpolationType, 0, 0, width, height, (double)n, (double)n2, (double)(n + width), (double)(n2 + height), true);
        return true;
    }
}
